#
# Conditional build:
%bcond_without	tests	# don't perform "make tests"
%bcond_without	zlib	# zlib: note - enables CVE-2012-4929 vulnerability
%bcond_with	sslv3	# SSLv3: note - enables CVE-2014-3566 vulnerability

Summary:	OpenSSL Toolkit libraries for the "Secure Sockets Layer" (SSL v2/v3)
Summary(de.UTF-8):	Secure Sockets Layer (SSL)-Kommunikationslibrary
Summary(es.UTF-8):	Biblioteca C que suministra algoritmos y protocolos criptográficos
Summary(fr.UTF-8):	Utilitaires de communication SSL (Secure Sockets Layer)
Summary(pl.UTF-8):	Biblioteki OpenSSL (SSL v2/v3)
Summary(pt_BR.UTF-8):	Uma biblioteca C que fornece vários algoritmos e protocolos criptográficos
Summary(ru.UTF-8):	Библиотеки и утилиты для соединений через Secure Sockets Layer
Summary(uk.UTF-8):	Бібліотеки та утиліти для з'єднань через Secure Sockets Layer
Name:		openssl
Version:	3.0.1
Release:	1
License:	Apache v2.0
Group:		Libraries
Source0:	https://www.openssl.org/source/%{name}-%{version}.tar.gz
# Source0-md5:	7d07e849d77d276891edd579a8832bb3
Source2:	%{name}.1.pl
Source3:	%{name}-ssl-certificate.sh
Source4:	%{name}-c_rehash.sh
Patch0:		%{name}-optflags.patch
Patch1:		%{name}-ca-certificates.patch
Patch2:		%{name}-find.patch
Patch3:		pic.patch
Patch4:		engines-dir.patch
URL:		http://www.openssl.org/
BuildRequires:	libsctp-devel
BuildRequires:	perl-devel >= 1:5.10.0
BuildRequires:	pkgconfig
BuildRequires:	rpm-perlprov >= 4.1-13
BuildRequires:	rpmbuild(macros) >= 1.213
BuildRequires:	sed >= 4.0
BuildRequires:	zlib-devel
Requires:	ca-certificates >= 20141019-3
Requires:	%{name}-tools = %{version}-%{release}
Requires:	rpm-whiteout >= 1.7
Obsoletes:	SSLeay
Obsoletes:	SSLeay-devel
Obsoletes:	SSLeay-perl
Obsoletes:	libopenssl0
Obsoletes:	openssl-engines < 3.0.0-2
%if "%{pld_release}" == "ac"
Conflicts:	neon < 0.26.3-3
Conflicts:	ntpd < 4.2.4p8-10
Conflicts:	openssh-clients < 2:5.8p1-9
Conflicts:	openssh-server < 2:5.8p1-9
%else
Conflicts:	neon < 0.29.6-8
Conflicts:	openssh-clients < 2:6.2p2-3
Conflicts:	openssh-server < 2:6.2p2-3
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The OpenSSL Project is a collaborative effort to develop a robust,
commercial-grade, full-featured, and Open Source toolkit implementing
the Secure Sockets Layer (SSL v2/v3) and Transport Layer Security (TLS
v1) protocols with full-strength cryptography world-wide. The project
is managed by a worldwide community of volunteers that use the
Internet to communicate, plan, and develop the OpenSSL tookit and its
related documentation.

OpenSSL is based on the excellent SSLeay library developed by Eric A.
Young and Tim J. Hudson. The OpenSSL toolkit is licensed under an
Apache-style licence, which basically means that you are free to get
and use it for commercial and non-commercial purposes subject to some
simple license conditions.

This package contains shared libraries only, install openssl-tools if
you want to use openssl cmdline tool.

%description -l de.UTF-8
Openssl enthält das OpenSSL Zertifikatsmanagementtool und shared
libraries, die verschiedene Verschlüsselungs- und
Entschlüsselungsalgorithmen und -protokolle, wie DES, RC4, RSA und SSL
zur Verfügung stellen.

%description -l es.UTF-8
Biblioteca C que suministra algoritmos y protocolos criptográficos.

%description -l fr.UTF-8
OpenSSL est un outiil de gestion des certificats et les librairies
partagees qui fournit plusieurs protocoles et algorithmes de
codage/decodage, incluant DES, RC4, RSA et SSL.

%description -l pl.UTF-8
Implementacja protokołów kryptograficznych Secure Socket Layer (SSL)
v2/v3 oraz Transport Layer Security (TLS v1).

%description -l pt_BR.UTF-8
Uma biblioteca C que fornece vários algoritmos e protocolos
criptográficos, incluindo DES, RC4, RSA e SSL. Inclui bibliotecas
compartilhadas e utilitários.

%description -l ru.UTF-8
Программа openssl для работы с сертификатами и разделяемые библиотеки,
которые реализуют множетсво криптографических алгоритмов, включая DES,
RC4, RSA и SSL.

%description -l uk.UTF-8
Програма openssl для роботи з сертифікатами та бібліотеки спільного
користування, що реалізують велику кількість криптографічних
алгоритмів, включаючи DES, RC4, RSA та SSL.

%package tools
Summary:	OpenSSL command line tool and utilities
Summary(pl.UTF-8):	Zestaw narzędzi i skryptów
Group:		Applications/Communications
Requires:	%{name} = %{version}-%{release}
Requires:	which

%description tools
The OpenSSL Toolkit cmdline tool openssl and utility scripts.

%description tools -l pl.UTF-8
Zestaw narzędzi i skryptów wywoływanych z linii poleceń.

%package tools-perl
Summary:	OpenSSL utilities written in Perl
Summary(pl.UTF-8):	Narzędzia OpenSSL napisane w perlu
Group:		Applications/Communications
Requires:	%{name} = %{version}-%{release}

%description tools-perl
OpenSSL Toolkit tools written in Perl.

%description tools-perl -l pl.UTF-8
Narzędzia OpenSSL napisane w perlu.

%package devel
Summary:	Development part of OpenSSL Toolkit libraries
Summary(de.UTF-8):	Secure Sockets Layer Kommunikationslibrary: statische libraries+header
Summary(es.UTF-8):	Bibliotecas y archivos de inclusión para desarrollo OpenSSL
Summary(fr.UTF-8):	Librairies statiques, headers et utilitaires pour communication SSL
Summary(pl.UTF-8):	Część bibiloteki OpenSSL przeznaczona dla programistów
Summary(pt_BR.UTF-8):	Bibliotecas e arquivos de inclusão para desenvolvimento OpenSSL
Summary(ru.UTF-8):	Библиотеки, хедеры и утилиты для Secure Sockets Layer
Summary(uk.UTF-8):	Бібліотеки, хедери та утиліти для Secure Sockets Layer
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Obsoletes:	libopenssl0-devel

%description devel
Development part of OpenSSL library.

%description devel -l es.UTF-8
Bibliotecas y archivos de inclusión para desarrollo OpenSSL

%description devel -l pl.UTF-8
Część biblioteki OpenSSL przeznaczona dla programistów.

%description devel -l pt_BR.UTF-8
Uma biblioteca C que fornece vários algoritmos e protocolos
criptográficos, incluindo DES, RC4, RSA e SSL. Inclui bibliotecas e
arquivos de inclusão para desenvolvimento.

%description devel -l ru.UTF-8
Программа openssl для работы с сертификатами и разделяемые библиотеки,
которые реализуют множетсво криптографических алгоритмов, включая DES,
RC4, RSA и SSL. Включает библиотеки и хедеры для разработки приложений
с использованием SSL.

%description devel -l uk.UTF-8
Програма openssl для роботи з сертифікатами та бібліотеки спільного
користування, що реалізують велику кількість криптографічних
алгоритмів, включаючи DES, RC4, RSA та SSL. Містить бібліотеки та
хедери для розробки програм з використанням SSL.

%package static
Summary:	Static OpenSSL libraries
Summary(pl.UTF-8):	Statyczne wersje bibliotek z OpenSSL
Summary(pt_BR.UTF-8):	Bibliotecas estáticas para desenvolvimento com openssl
Summary(ru.UTF-8):	Статические библиотеки разработчика для OpenSSL
Summary(uk.UTF-8):	Статичні бібліотеки програміста для OpenSSL
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static OpenSSL Toolkit libraries.

%description static -l pl.UTF-8
Statyczne wersje bibliotek z OpenSSL.

%description static -l pt_BR.UTF-8
Bibliotecas estáticas para desenvolvimento com openssl.

%description static -l ru.UTF-8
Программа openssl для работы с сертификатами и разделяемые библиотеки,
которые реализуют множетсво криптографических алгоритмов, включая DES,
RC4, RSA и SSL. Включает статические библиотеки для разработки
приложений с использованием OpenSSL.

%description static -l uk.UTF-8
Програма openssl для роботи з сертифікатами та бібліотеки спільного
користування, що реалізують велику кількість криптографічних
алгоритмів, включаючи DES, RC4, RSA та SSL. Містить статичні
бібліотеки для розробки програм з використанням SSL.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1

# fails with enable-sctp as of 1.1.1
%{__rm} test/recipes/80-test_ssl_new.t

%build
touch Makefile.*

PERL="%{__perl}" \
%{__perl} ./Configure \
	--prefix=%{_prefix} \
	--openssldir=%{_sysconfdir}/%{name} \
	--libdir=%{_lib} \
	-Wa,--noexecstack \
	shared \
	threads \
	%{?with_sslv3:enable-ssl3}%{!?with_sslv3:no-ssl3} \
	%{!?with_zlib:no-}zlib \
	enable-cms \
	enable-idea \
	enable-md2 \
	enable-mdc2 \
	enable-rc5 \
	enable-rfc3779 \
	enable-sctp \
	enable-seed \
	enable-camellia \
	enable-ktls \
	enable-fips \
%ifarch %{x8664}
	enable-ec_nistp_64_gcc_128 \
%endif
%ifarch %{ix86}
%ifarch i386
	386 linux-elf
# ^- allow running on 80386 (default code uses bswapl available on i486+)
%else
	linux-elf
%endif
%endif
%ifarch alpha
	linux-alpha-gcc
%endif
%ifarch %{x8664}
	linux-x86_64
%endif
%ifarch x32
	linux-x32
%endif
%ifarch ia64
	linux-ia64
%endif
%ifarch ppc
	linux-ppc
%endif
%ifarch ppc64
	linux-ppc64
%endif
%ifarch sparc
	linux-sparcv8
%endif
%ifarch sparcv9
	linux-sparcv9
%endif
%ifarch sparc64
	linux64-sparcv9
%endif
%ifarch %{arm}
	linux-armv4
%endif
%ifarch aarch64
	linux-aarch64
%endif

v=$(awk -F= '/^VERSION=/{print $2}' Makefile)
test "$v" = %{version}

%{__make} -j1 all %{?with_tests:tests} \
	CC="%{__cc}" \
	OPTFLAGS="%{rpmcflags} %{rpmcppflags}" \
	INSTALLTOP=%{_prefix}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sysconfdir}/%{name},%{_libdir}/%{name}} \
	$RPM_BUILD_ROOT{%{_mandir}/{pl/man1,man{1,3,5,7}},%{_datadir}/ssl} \
	$RPM_BUILD_ROOT%{_pkgconfigdir}

%{__make} -j1 install \
	CC="%{__cc}" \
	DESTDIR=$RPM_BUILD_ROOT

%{__mv} $RPM_BUILD_ROOT%{_libdir}/lib*.so.* $RPM_BUILD_ROOT/%{_lib}
ln -sf /%{_lib}/$(basename $RPM_BUILD_ROOT/%{_lib}/libcrypto.*) $RPM_BUILD_ROOT%{_libdir}/libcrypto.so
ln -sf /%{_lib}/$(basename $RPM_BUILD_ROOT/%{_lib}/libssl.*) $RPM_BUILD_ROOT%{_libdir}/libssl.so

%{__mv} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/misc/* $RPM_BUILD_ROOT%{_libdir}/%{name}
%{__rm} -r $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/misc

# html version of man pages - not packaged
%{__rm} -r $RPM_BUILD_ROOT%{_docdir}/%{name}/html/man[1357]

cp -p %{SOURCE2} $RPM_BUILD_ROOT%{_mandir}/pl/man1/openssl.1
install -p %{SOURCE3} $RPM_BUILD_ROOT%{_bindir}/ssl-certificate
install -p %{SOURCE4} $RPM_BUILD_ROOT%{_bindir}/c_rehash.sh

%clean
rm -rf $RPM_BUILD_ROOT

%post   -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%triggerpostun -- %{name}-tools < 1.0.0-5
# the hashing format has changed in 1.0.0
[ ! -x %{_sbindir}/update-ca-certificates ] || %{_sbindir}/update-ca-certificates --fresh || :

%triggerpostun -- %{name} < 0.9.8i-2
# don't do anything on --downgrade
if [ $1 -le 1 ]; then
	exit 0
fi
if [ -d /var/lib/openssl/certs ] ; then
	mv /var/lib/openssl/certs/* %{_sysconfdir}/%{name}/certs 2>/dev/null || :
fi
if [ -d /var/lib/openssl/private ] ; then
	mv /var/lib/openssl/private/* %{_sysconfdir}/%{name}/private 2>/dev/null || :
fi
if [ -d /var/lib/openssl ] ; then
	for f in /var/lib/openssl/* ; do
		[ -f "$f" ] && mv "$f" %{_sysconfdir}/%{name} 2>/dev/null || :
	done
	rmdir /var/lib/openssl/* 2>/dev/null || :
	rmdir /var/lib/openssl 2>/dev/null || :
fi

%files
%defattr(644,root,root,755)
%doc CHANGES.md NEWS.md README.md doc/*.txt
%attr(755,root,root) /%{_lib}/libcrypto.so.*
%attr(755,root,root) /%{_lib}/libssl.so.*
%dir /%{_lib}/engines-3
%attr(755,root,root) /%{_lib}/engines-3/*.so
%dir /%{_lib}/ossl-modules
%attr(755,root,root) /%{_lib}/ossl-modules/fips.so
%attr(755,root,root) /%{_lib}/ossl-modules/legacy.so
%dir %{_sysconfdir}/%{name}
%dir %{_sysconfdir}/%{name}/certs
%dir %attr(700,root,root) %{_sysconfdir}/%{name}/private
%dir %{_datadir}/ssl

%files tools
%defattr(644,root,root,755)
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/%{name}/ct_log_list.cnf
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/%{name}/fipsmodule.cnf
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/%{name}/openssl.cnf
%attr(755,root,root) %{_bindir}/c_rehash.sh
%attr(755,root,root) %{_bindir}/openssl
%attr(754,root,root) %{_bindir}/ssl-certificate
%{_mandir}/man1/asn1parse.1*
%{_mandir}/man1/ca.1*
%{_mandir}/man1/ciphers.1*
%{_mandir}/man1/cms.1*
%{_mandir}/man1/crl.1*
%{_mandir}/man1/crl2pkcs7.1*
%{_mandir}/man1/dgst.1*
%{_mandir}/man1/dhparam.1*
%{_mandir}/man1/dsa.1*
%{_mandir}/man1/dsaparam.1*
%{_mandir}/man1/ec.1*
%{_mandir}/man1/ecparam.1*
%{_mandir}/man1/enc.1*
%{_mandir}/man1/engine.1*
%{_mandir}/man1/errstr.1*
%{_mandir}/man1/gendsa.1*
%{_mandir}/man1/genpkey.1*
%{_mandir}/man1/genrsa.1*
%{_mandir}/man1/kdf.1*
%{_mandir}/man1/mac.1*
%{_mandir}/man1/nseq.1*
%{_mandir}/man1/ocsp.1*
%{_mandir}/man1/openssl.1*
%{_mandir}/man1/openssl-*.1*
%{_mandir}/man1/passwd.1*
%{_mandir}/man1/pkcs12.1*
%{_mandir}/man1/pkcs7.1*
%{_mandir}/man1/pkcs8.1*
%{_mandir}/man1/pkey.1*
%{_mandir}/man1/pkeyparam.1*
%{_mandir}/man1/pkeyutl.1*
%{_mandir}/man1/prime.1*
%{_mandir}/man1/rand.1*
%{_mandir}/man1/rehash.1*
%{_mandir}/man1/req.1*
%{_mandir}/man1/rsa.1*
%{_mandir}/man1/rsautl.1*
%{_mandir}/man1/s_client.1*
%{_mandir}/man1/sess_id.1*
%{_mandir}/man1/smime.1*
%{_mandir}/man1/speed.1*
%{_mandir}/man1/spkac.1*
%{_mandir}/man1/srp.1*
%{_mandir}/man1/s_server.1*
%{_mandir}/man1/s_time.1*
%{_mandir}/man1/storeutl.1*
%{_mandir}/man1/ts.1*
%{_mandir}/man1/verify.1*
%{_mandir}/man1/version.1*
%{_mandir}/man1/x509.1*
%{_mandir}/man5/*.5*
%lang(pl) %{_mandir}/pl/man1/openssl.1*

%files tools-perl
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/c_rehash
%dir %{_libdir}/%{name}
%attr(755,root,root) %{_libdir}/%{name}/CA.pl
%attr(755,root,root) %{_libdir}/%{name}/tsget
%attr(755,root,root) %{_libdir}/%{name}/tsget.pl
%{_mandir}/man1/CA.pl.1*
%{_mandir}/man1/c_rehash.1*
%{_mandir}/man1/tsget.1*

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libcrypto.so
%attr(755,root,root) %{_libdir}/libssl.so
%{_includedir}/%{name}
%{_pkgconfigdir}/libcrypto.pc
%{_pkgconfigdir}/libssl.pc
%{_pkgconfigdir}/openssl.pc
%{_mandir}/man3/*.3*
%{_mandir}/man7/*.7*

%files static
%defattr(644,root,root,755)
%{_libdir}/libcrypto.a
%{_libdir}/libssl.a
%changelog
* Tue Dec 14 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/openssl.git;a=log;h=master

* Tue Dec 14 2021 Jan Palus <atler@pld-linux.org> 7aa6910
- up to 3.0.1 (fixes CVE-2021-4044)

* Sun Oct 10 2021 Jan Rękorajski <baggins@pld-linux.org> efa15d6
- enable FIPS provider and Kernel TLS support
- merge engines into main package, there is no reason to keep it separated now
- main package requires tools, the lib (esp. FIPS) is half-useless without config

* Sun Sep 19 2021 Jan Rękorajski <baggins@pld-linux.org> 3f69fe9
- up to 3.0.0
- removed obsolete bconds and macros
- simplified files

* Wed Aug 25 2021 Jan Palus <atler@pld-linux.org> 0bab647
- up to 1.1.1l (fixes CVE-2021-3711 CVE-2021-3712)

* Thu Mar 25 2021 Jan Palus <atler@pld-linux.org> 822ea7c
- up to 1.1.1k (fixes CVE-2021-3449 CVE-2021-3450)

* Wed Feb 17 2021 Jan Palus <atler@pld-linux.org> f618cc9
- up to 1.1.1j (fixes CVE-2021-23841 CVE-2021-23839 CVE-2021-23840)

* Tue Dec 08 2020 Jakub Bogusz <qboosh@pld-linux.org> b51a91b
- updated md5

* Tue Dec 08 2020 Elan Ruusamäe <glen@pld-linux.org> 76c896a
- Update to 1.1.1i, (CVE-2020-1971)

* Tue Dec 01 2020 Elan Ruusamäe <glen@pld-linux.org> 102adab
- Restore snap bcond from dev-1.1 branch

* Tue Oct 13 2020 Jakub Bogusz <qboosh@pld-linux.org> 5333683
- updated to 1.1.1h

* Thu Mar 17 2016 Mike Frysinger <vapier@gentoo.org> 96dc38e
- openssl-ssl-certificate.sh: fix test POSIX compatibility

* Tue Apr 21 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> 4bb74c5
- up to 1.1.1g; fixes CVE-2020-1967

* Sun Apr 05 2020 Jan Palus <atler@pld-linux.org> 0f94134
- up to 1.1.1f

* Sun Mar 29 2020 Jakub Bogusz <qboosh@pld-linux.org> deddbbf
- removed leftover

* Sun Mar 29 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> d3102ab
- up to 1.1.1e; fixes CVE-2019-1551

* Sat Jan 25 2020 Jan Rękorajski <baggins@pld-linux.org> 16a90de
- drop obsolete and outdated manual inclusion of rpm macros

* Fri Sep 27 2019 Jakub Bogusz <qboosh@pld-linux.org> f160409
- updated to 1.1.1d (fixes CVE-2019-1547 CVE-2019-1549 CVE-2019-1563)
- added no-win32 patch (don't require Win32-specific perl module for unix installs)
- added zlib-fix patch (bugfix from git)

* Wed May 29 2019 Adam Gołębiowski <adamg@pld-linux.org> e221e23
- updated to 1.1.1c (solves CVE-2019-1543)

* Wed Feb 27 2019 Adam Gołębiowski <adamg@pld-linux.org> 7b2191a
- updated to 1.1.1b

* Tue Nov 20 2018 Adam Gołębiowski <adamg@pld-linux.org> 0283944
- updated to 1.1.1a, solves CVE-2018-0734, CVE-2017-0735
- BR: libsctp-devel

